OPT MODULE
OPT EXPORT

->  Procedura wycinajca rozszerzenie z nazwy pliku
->  IN  -> get_suffix(nazwapliku)
->  OUT -> rozszerzenie
->
->  Uycie -> rozszerzenie := get_suffix('E-Src/Multiview.e')
->  Wynik  -> .e


PROC get_suffix(filename : PTR TO CHAR)

  DEF pos,
      tmp[32] : STRING

   IF InStr(filename,'.') > -1
    pos := StrLen(filename) - 1
    WHILE filename[pos] <> "."
      pos--
    ENDWHILE
    MidStr(tmp,filename,pos,ALL)
  ENDIF

ENDPROC tmp

->  Procedura wycinajca przedrostek z nazwy pliku
->  IN  -> get_prefix(nazwapliku)
->  OUT -> rozszerzenie
->
->  Uycie -> rozszerzenie := get_suffix('E-Src/mod.test.e')
->  Wynik  -> mod.

PROC get_prefix(filename : PTR TO CHAR)

  DEF pos = 1,
      tmp  [32] : STRING,
      fname[32] : STRING

  StrCopy(fname,FilePart(filename))

  IF InStr(fname,'.') > -1
    WHILE fname[pos] <> "."
      pos++
    ENDWHILE
    MidStr(tmp,fname,NIL,pos + 1)
  ENDIF

ENDPROC tmp

